package com.zheng.demo.mapper;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;

import com.zheng.demo.data.Car;
import com.zheng.demo.data.CarDto;
import com.zheng.demo.data.Train;
import com.zheng.demo.data.TrainDto;
import com.zheng.demo.data.Vehicle;
import com.zheng.demo.data.VehicleDto;

@Mapper()
public interface VehicleMapper_InstanceCheck {
	@Mapping(target = "seatCount", source = "numberOfSeats")
	CarDto map(Car car);
	TrainDto map(Train train);

	default VehicleDto mapToVehicleDto(Vehicle vehicle) {
		if (vehicle instanceof Train) {
			return map((Train) vehicle);
		} else if (vehicle instanceof Car) {
			return map((Car) vehicle);
		} else {
			return null;
		}
	}
}