package com.zheng.demo.mapper;

import org.mapstruct.Mapper;
import org.mapstruct.SubclassMapping;

import com.zheng.demo.data.Car;
import com.zheng.demo.data.CarDto;
import com.zheng.demo.data.Train;
import com.zheng.demo.data.TrainDto;
import com.zheng.demo.data.Vehicle;
import com.zheng.demo.data.VehicleDto;

@Mapper(uses = { CarMapper.class, TrainMapper.class })
public interface VehicleMapper_SubclassMapping {
	@SubclassMapping(source = CarDto.class, target = Car.class)
	@SubclassMapping(source = TrainDto.class, target = Train.class)
	Vehicle dtoToVehicle(VehicleDto vehicleDto);

	@SubclassMapping(source = Car.class, target = CarDto.class)
	@SubclassMapping(source = Train.class, target = TrainDto.class)
	VehicleDto vehicleToDto(Vehicle vehicle);
}
