package com.zheng.demo.mapper;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.jupiter.api.Test;

import com.zheng.demo.data.Car;
import com.zheng.demo.data.CarDto;

class CarMapperTest {

	private Car dummyCar() {
		Car car = new Car("Morris", 5, "SEDAN");
		car.setColor("white");
		car.setSpeed("50mph");
		return car;
	}

	@Test
	void test_CarMapper() {
		// given
		Car car = dummyCar();

		// when
		CarDto carDto = CarMapper.INSTANCE.carToCarDto(car);

		// then
		assertThat(carDto).isNotNull();
		assertThat(carDto.getMake()).isEqualTo(car.getMake());
		assertThat(carDto.getSeatCount()).isEqualTo(car.getNumberOfSeats());
		assertThat(carDto.getType()).isEqualTo(car.getType());
		assertThat(carDto.getColor()).isEqualTo(car.getColor());
		assertThat(carDto.getSpeed()).isEqualTo(car.getSpeed());

		Car car2 = CarMapper.INSTANCE.carDtoToCar(carDto);
		
		assertThat(car2).isNotNull();
		assertThat(car2.getMake()).isEqualTo(carDto.getMake());
		assertThat(car2.getNumberOfSeats()).isEqualTo(carDto.getSeatCount());
		assertThat(car2.getType()).isEqualTo(carDto.getType());
		assertThat(car2.getColor()).isEqualTo(carDto.getColor());
		assertThat(car2.getSpeed()).isEqualTo(carDto.getSpeed());
	}

}
