package com.zheng.demo.mapper;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.jupiter.api.Test;

import com.zheng.demo.data.Train;
import com.zheng.demo.data.TrainDto;

class TrainMapperTest {

	private TrainMapper mapper = new TrainMapperImpl();

	private Train dummyTrain() {
		return Train.builder().speed("50mph").color("white").numberOfKarts(5).build();
	}

	@Test
	void test_TrainMapper() {
		// given
		Train train = dummyTrain();

		// when
		TrainDto trainDto = mapper.trainToTrainDto(train);

		// then
		assertThat(trainDto).isNotNull();

		assertThat(trainDto.getNumberOfKarts()).isEqualTo(train.getNumberOfKarts());
		assertThat(trainDto.getColor()).isEqualTo(train.getColor());
		assertThat(trainDto.getSpeed()).isEqualTo(train.getSpeed());

		Train train2 = mapper.trainDtoToTrain(trainDto);

		assertThat(train2).isNotNull();

		assertThat(train2.getNumberOfKarts()).isEqualTo(trainDto.getNumberOfKarts());
		assertThat(train2.getColor()).isEqualTo(trainDto.getColor());
		assertThat(train2.getSpeed()).isEqualTo(trainDto.getSpeed());
	}
}
