package com.zheng.demo.mapper;

import static org.assertj.core.api.Assertions.assertThat;
import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertTrue;

import org.junit.jupiter.api.Test;

import com.zheng.demo.data.Car;
import com.zheng.demo.data.CarDto;
import com.zheng.demo.data.Vehicle;
import com.zheng.demo.data.VehicleDto;

class VehicleMapperTest {

	private VehicleMapper mapper = new VehicleMapperImpl();

	@Test
	void test_issue_car_not_not_to_carDto_on_vehicle_mapping() {
		Vehicle vh = new Vehicle();
		vh.setColor("white");
		vh.setSpeed("50mph");

		VehicleDto vhDto = mapper.vehicleToDto(vh);

		assertThat(vhDto).isNotNull();
		assertThat(vhDto.getColor()).isEqualTo(vh.getColor());
		assertThat(vhDto.getSpeed()).isEqualTo(vh.getSpeed());

		Vehicle vh2 = mapper.dtoToVehicle(vhDto);

		assertThat(vh2).isNotNull();
		assertThat(vh2.getColor()).isEqualTo(vhDto.getColor());
		assertThat(vh2.getSpeed()).isEqualTo(vhDto.getSpeed());

		Car car = new Car("Morris", 5, "SEDAN");

		VehicleDto vehicleDto = mapper.vehicleToDto(car);

		assertTrue(vehicleDto instanceof VehicleDto);

		// This is the issue as the Car did not map to CarDto @SubMapping fix it
		assertFalse(vehicleDto instanceof CarDto);
	}
}
