package com.zheng.demo.mapper;

import static org.assertj.core.api.Assertions.assertThat;
import static org.junit.jupiter.api.Assertions.assertTrue;

import org.junit.jupiter.api.Test;

import com.zheng.demo.data.Car;
import com.zheng.demo.data.CarDto;
import com.zheng.demo.data.VehicleDto;

class VehicleMapper_InstanceCheckTest {

	private VehicleMapper_InstanceCheck mapper = new VehicleMapper_InstanceCheckImpl();

	@Test
	void shouldMapParentAndChildFields() {
		Car car = Car.builder().numberOfSeats(6).color("white").make("Chevrolet").type("Malibu").speed("50mph").build();

		VehicleDto vehicleDto = mapper.mapToVehicleDto(car);

		assertThat(vehicleDto).isNotNull();
		//addressed the inheritance
		assertTrue(vehicleDto instanceof CarDto);
		assertThat(car.getMake()).isEqualTo(((CarDto) vehicleDto).getMake());
		assertThat(car.getNumberOfSeats()).isEqualTo(((CarDto) vehicleDto).getSeatCount());
		assertThat(car.getType()).isEqualTo(((CarDto) vehicleDto).getType());
		assertThat(car.getColor()).isEqualTo(vehicleDto.getColor());
		assertThat(car.getSpeed()).isEqualTo(vehicleDto.getSpeed());
	}

}
